const name = {
    name: 'name',
    regexp: /^[a-zA-Zа-яА-Яё]{2,}$/,
    error: 'Неверно заполнено имя'
}
const email = {
    name: 'email',
    regexp: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
    error: 'Неверный email'
}
const mobile = {
    name: 'mobile',
    regexp: /^\+7 \(\d{3}\) \d{3}-\d{4}$/,
    error: 'Неверный телефон, укажите в формате +7 (999) 999-9999'
}
const password = {
    name: 'password',
    regexp: /^.{6,}$/,
    error: 'Пароль должен быть минимум 6 символов'
}
const phone = {
    name: 'phone',
    regexp: /^[+\d\-( )]{5,}$/,
    error: 'Неверно указан номер телефона'
}
const number = {
    name: 'number',
    regexp: /^\d+$/,
    error: 'Можно вводить только числа'
}

export default {
    name,
    email,
    mobile,
    password,
    phone,
    number
}